/*
 * Generated by PEG.js 0.10.0.
 *
 * http://pegjs.org/
 */

(function () {
    function jsonBean() {
        "use strict";
        
        function peg$subclass(child, parent) {
            function ctor() { this.constructor = child; }
            
            ctor.prototype  = parent.prototype;
            child.prototype = new ctor();
        }
        
        function peg$SyntaxError(message, expected, found, location) {
            this.message  = message;
            this.expected = expected;
            this.found    = found;
            this.location = location;
            this.name     = "SyntaxError";
            
            if (typeof Error.captureStackTrace === "function") {
                Error.captureStackTrace(this, peg$SyntaxError);
            }
        }
        
        peg$subclass(peg$SyntaxError, Error);
        
        peg$SyntaxError.buildMessage = function (expected, found) {
            var DESCRIBE_EXPECTATION_FNS = {
                literal: function (expectation) {
                    return "\"" + literalEscape(expectation.text) + "\"";
                },
                
                "class": function (expectation) {
                    var escapedParts = "",
                        i;
                    
                    for (i = 0; i < expectation.parts.length; i++) {
                        escapedParts += expectation.parts[i] instanceof Array
                            ? classEscape(expectation.parts[i][0]) + "-" + classEscape(expectation.parts[i][1])
                            : classEscape(expectation.parts[i]);
                    }
                    
                    return "[" + (expectation.inverted ? "^" : "") + escapedParts + "]";
                },
                
                any: function (expectation) {
                    return "any character";
                },
                
                end: function (expectation) {
                    return "end of input";
                },
                
                other: function (expectation) {
                    return expectation.description;
                }
            };
            
            function hex(ch) {
                return ch.charCodeAt(0).toString(16).toUpperCase();
            }
            
            function literalEscape(s) {
                return s
                    .replace(/\\/g, '\\\\')
                    .replace(/"/g, '\\"')
                    .replace(/\0/g, '\\0')
                    .replace(/\t/g, '\\t')
                    .replace(/\n/g, '\\n')
                    .replace(/\r/g, '\\r')
                    .replace(/[\x00-\x0F]/g, function (ch) { return '\\x0' + hex(ch); })
                    .replace(/[\x10-\x1F\x7F-\x9F]/g, function (ch) { return '\\x' + hex(ch); });
            }
            
            function classEscape(s) {
                return s
                    .replace(/\\/g, '\\\\')
                    .replace(/\]/g, '\\]')
                    .replace(/\^/g, '\\^')
                    .replace(/-/g, '\\-')
                    .replace(/\0/g, '\\0')
                    .replace(/\t/g, '\\t')
                    .replace(/\n/g, '\\n')
                    .replace(/\r/g, '\\r')
                    .replace(/[\x00-\x0F]/g, function (ch) { return '\\x0' + hex(ch); })
                    .replace(/[\x10-\x1F\x7F-\x9F]/g, function (ch) { return '\\x' + hex(ch); });
            }
            
            function describeExpectation(expectation) {
                return DESCRIBE_EXPECTATION_FNS[expectation.type](expectation);
            }
            
            function describeExpected(expected) {
                var descriptions = new Array(expected.length),
                    i, j;
                
                for (i = 0; i < expected.length; i++) {
                    descriptions[i] = describeExpectation(expected[i]);
                }
                
                descriptions.sort();
                
                if (descriptions.length > 0) {
                    for (i = 1, j = 1; i < descriptions.length; i++) {
                        if (descriptions[i - 1] !== descriptions[i]) {
                            descriptions[j] = descriptions[i];
                            j++;
                        }
                    }
                    descriptions.length = j;
                }
                
                switch (descriptions.length) {
                    case 1:
                        return descriptions[0];
                    
                    case 2:
                        return descriptions[0] + " or " + descriptions[1];
                    
                    default:
                        return descriptions.slice(0, -1).join(", ")
                            + ", or "
                            + descriptions[descriptions.length - 1];
                }
            }
            
            function describeFound(found) {
                return found ? "\"" + literalEscape(found) + "\"" : "end of input";
            }
            
            return "Expected " + describeExpected(expected) + " but " + describeFound(found) + " found.";
        };
        
        function peg$parse(input, options) {
            options = options !== void 0 ? options : {};
            
            var peg$FAILED             = {},
            
                peg$startRuleFunctions = {Start: peg$parseStart},
                peg$startRuleFunction  = peg$parseStart,
            
                peg$c0                 = function (items) {
                    var result = {
                        name       : '',
                        description: '',
                        attributes : []
                    }
                    items.forEach(function (item) {
                        if (item === null) return;
                        if (item.class) {
                            result.name        = item.class
                            result.description = item.description
                        } else if (item.name) {
                            result.attributes.push(item)
                        }
                    })
                    return result
                },
                peg$c1                 = function () {
                    return "" // ignore
                },
                peg$c2                 = ";",
                peg$c3                 = peg$literalExpectation(";", false),
                peg$c4                 = function (ct, f, dt, name, arr, dv, cl) {
                    if (f) {
                        return null;
                    }
                    return {
                        name        : name.join(''),
                        type        : dt.name,
                        isArray     : dt.isArray || (arr ? true : false),
                        defaultValue: dv == null ? "" : dv,
                        description : ct.join('') || cl
                    }
                },
                peg$c5                 = "public",
                peg$c6                 = peg$literalExpectation("public", false),
                peg$c7                 = "class",
                peg$c8                 = peg$literalExpectation("class", false),
                peg$c9                 = "{",
                peg$c10                = peg$literalExpectation("{", false),
                peg$c11                = function (ct, clazz) {
                    return {
                        description: ct.join(''),
                        class      : clazz
                    }
                },
                peg$c12                = "}",
                peg$c13                = peg$literalExpectation("}", false),
                peg$c14                = function () {
                    return null
                },
                peg$c15                = function (a) {
                    return null
                },
                peg$c16                = "[",
                peg$c17                = peg$literalExpectation("[", false),
                peg$c18                = "]",
                peg$c19                = peg$literalExpectation("]", false),
                peg$c20                = function (i) {return true;},
                peg$c21                = "List",
                peg$c22                = peg$literalExpectation("List", false),
                peg$c23                = "<",
                peg$c24                = peg$literalExpectation("<", false),
                peg$c25                = ">",
                peg$c26                = peg$literalExpectation(">", false),
                peg$c27                = function (w) {
                    return {
                        name   : w,
                        isArray: true
                    }
                },
                peg$c28                = function (w, arr) {
                    return {
                        name   : w,
                        isArray: true
                    }
                },
                peg$c29                = function (w) {
                    return {
                        name   : w,
                        isArray: false
                    }
                },
                peg$c30                = "@",
                peg$c31                = peg$literalExpectation("@", false),
                peg$c32                = "private",
                peg$c33                = peg$literalExpectation("private", false),
                peg$c34                = "protected",
                peg$c35                = peg$literalExpectation("protected", false),
                peg$c36                = "static",
                peg$c37                = peg$literalExpectation("static", false),
                peg$c38                = "final",
                peg$c39                = peg$literalExpectation("final", false),
                peg$c40                = "transient",
                peg$c41                = peg$literalExpectation("transient", false),
                peg$c42                = "volatile",
                peg$c43                = peg$literalExpectation("volatile", false),
                peg$c44                = function (s, f) {
                    /*
                     如果把一个member定义为final意味着无法改变，此时该member不应导入
                     而static则是类的，也不应该导入
                     如： 有些时候JavaBean会implements一些interface(如Seriablizable)，就需要定义一个static final long 的serialVersionUID，显然这个member是不应该被导入的
                     */
                    return f === "final" || s === 'static';
                },
                peg$c45                = "=",
                peg$c46                = peg$literalExpectation("=", false),
                peg$c47                = function (d) {
                    return d;
                
                },
                peg$c48                = ",",
                peg$c49                = peg$literalExpectation(",", false),
                peg$c50                = function (s, ss) {
                    var temp = ss.map(function (item) { return item[2];});
                    temp.unshift(s);
                    return {
                        notArray: true,
                        value   : temp
                    };
                },
                peg$c51                = function (v, vv) {
                    // 支持一下几种:
                    // [1,2,3]
                    // [[1,2,3],[4,5,6]]
                    // ["test", "it",["a", "test]];  parser中对这种差异性不处理,不进行类型检查。
                    if (v.notArray) {
                        return v.value;
                    } else {
                        var temp = new Array();
                        temp.push(v);
                        if (vv.length == 0) {
                            return temp;
                        } else {
                            var vvTemp = vv.map(function (item) {return item[2]});
                            return temp.concat(vvTemp);
                        }
                    }
                },
                peg$c52                = "//",
                peg$c53                = peg$literalExpectation("//", false),
                peg$c54                = function (c) { // 因为都是包在一个java class 中, 所以一定有LB
                    return c.join('')
                },
                peg$c55                = function (c) {
                    return c
                },
                peg$c56                = /^[\/]/,
                peg$c57                = peg$classExpectation(["/"], false, false),
                peg$c58                = /^[*]/,
                peg$c59                = peg$classExpectation(["*"], false, false),
                peg$c60                = "*/",
                peg$c61                = peg$literalExpectation("*/", false),
                peg$c62                = peg$anyExpectation(),
                peg$c63                = function (c) {
                    var comments = c.map(function (item) {
                        return item[1]
                    }).join('').split('\n')
                    var result   = []
                    comments.forEach(function (comment) {
                        var trimResult = comment.trim().replace(/^\*+|\*+$/g, '').trim()
                        if (trimResult) {
                            result.push(trimResult)
                        }
                    })
                    return result.join(', ')
                },
                peg$c64                = "\"",
                peg$c65                = peg$literalExpectation("\"", false),
                peg$c66                = /^[^"]/,
                peg$c67                = peg$classExpectation(["\""], true, false),
                peg$c68                = function (s) {
                    return s.join('');
                },
                peg$c69                = function (f) {
                    return f.map(function (i) {
                        if (i instanceof Array) {
                            return i.join('')
                        } else return i
                    }).join('');
                },
                peg$c70                = /^[0-9]/,
                peg$c71                = peg$classExpectation([["0", "9"]], false, false),
                peg$c72                = /^[eE]/,
                peg$c73                = peg$classExpectation(["e", "E"], false, false),
                peg$c74                = /^[+\-]/,
                peg$c75                = peg$classExpectation(["+", "-"], false, false),
                peg$c76                = function (e, s, ds) {
                    return e + (s == null ? "" : s) + ds.join('');
                },
                peg$c77                = ".",
                peg$c78                = peg$literalExpectation(".", false),
                peg$c79                = function (s, d) {
                    return (s == '-' ? -1 : 1) * Number(d.join(''));
                },
                peg$c80                = function (l) {
                    return l.join('');
                },
                peg$c81                = /^[a-zA-Z0-9]/,
                peg$c82                = peg$classExpectation([["a", "z"], ["A", "Z"], ["0", "9"]], false, false),
                peg$c83                = peg$otherExpectation("Whitespace"),
                peg$c84                = /^[ \t]/,
                peg$c85                = peg$classExpectation([" ", "\t"], false, false),
                peg$c86                = peg$otherExpectation("Zero or more whitespaces"),
                peg$c87                = peg$otherExpectation("One or more whitespaces"),
                peg$c88                = /^[\r\n]/,
                peg$c89                = peg$classExpectation(["\r", "\n"], false, false),
                peg$c90                = /^[^;{]/,
                peg$c91                = peg$classExpectation([";", "{"], true, false),
                peg$c92                = /^[^\r\n]/,
                peg$c93                = peg$classExpectation(["\r", "\n"], true, false),
            
                peg$currPos            = 0,
                peg$savedPos           = 0,
                peg$posDetailsCache    = [{line: 1, column: 1}],
                peg$maxFailPos         = 0,
                peg$maxFailExpected    = [],
                peg$silentFails        = 0,
            
                peg$result;
            
            if ("startRule" in options) {
                if (!(options.startRule in peg$startRuleFunctions)) {
                    throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
                }
                
                peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
            }
            
            function text() {
                return input.substring(peg$savedPos, peg$currPos);
            }
            
            function location() {
                return peg$computeLocation(peg$savedPos, peg$currPos);
            }
            
            function expected(description, location) {
                location = location !== void 0 ? location : peg$computeLocation(peg$savedPos, peg$currPos)
                
                throw peg$buildStructuredError(
                    [peg$otherExpectation(description)],
                    input.substring(peg$savedPos, peg$currPos),
                    location
                );
            }
            
            function error(message, location) {
                location = location !== void 0 ? location : peg$computeLocation(peg$savedPos, peg$currPos)
                
                throw peg$buildSimpleError(message, location);
            }
            
            function peg$literalExpectation(text, ignoreCase) {
                return {type: "literal", text: text, ignoreCase: ignoreCase};
            }
            
            function peg$classExpectation(parts, inverted, ignoreCase) {
                return {type: "class", parts: parts, inverted: inverted, ignoreCase: ignoreCase};
            }
            
            function peg$anyExpectation() {
                return {type: "any"};
            }
            
            function peg$endExpectation() {
                return {type: "end"};
            }
            
            function peg$otherExpectation(description) {
                return {type: "other", description: description};
            }
            
            function peg$computePosDetails(pos) {
                var details = peg$posDetailsCache[pos], p;
                
                if (details) {
                    return details;
                } else {
                    p = pos - 1;
                    while (!peg$posDetailsCache[p]) {
                        p--;
                    }
                    
                    details = peg$posDetailsCache[p];
                    details = {
                        line  : details.line,
                        column: details.column
                    };
                    
                    while (p < pos) {
                        if (input.charCodeAt(p) === 10) {
                            details.line++;
                            details.column = 1;
                        } else {
                            details.column++;
                        }
                        
                        p++;
                    }
                    
                    peg$posDetailsCache[pos] = details;
                    return details;
                }
            }
            
            function peg$computeLocation(startPos, endPos) {
                var startPosDetails = peg$computePosDetails(startPos),
                    endPosDetails   = peg$computePosDetails(endPos);
                
                return {
                    start: {
                        offset: startPos,
                        line  : startPosDetails.line,
                        column: startPosDetails.column
                    },
                    end  : {
                        offset: endPos,
                        line  : endPosDetails.line,
                        column: endPosDetails.column
                    }
                };
            }
            
            function peg$fail(expected) {
                if (peg$currPos < peg$maxFailPos) {
                    return;
                }
                
                if (peg$currPos > peg$maxFailPos) {
                    peg$maxFailPos      = peg$currPos;
                    peg$maxFailExpected = [];
                }
                
                peg$maxFailExpected.push(expected);
            }
            
            function peg$buildSimpleError(message, location) {
                return new peg$SyntaxError(message, null, null, location);
            }
            
            function peg$buildStructuredError(expected, found, location) {
                return new peg$SyntaxError(
                    peg$SyntaxError.buildMessage(expected, found),
                    expected,
                    found,
                    location
                );
            }
            
            function peg$parseStart() {
                var s0, s1, s2;
                
                s0 = peg$currPos;
                s1 = [];
                s2 = peg$parseStatement();
                if (s2 !== peg$FAILED) {
                    while (s2 !== peg$FAILED) {
                        s1.push(s2);
                        s2 = peg$parseStatement();
                    }
                } else {
                    s1 = peg$FAILED;
                }
                if (s1 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1           = peg$c0(s1);
                }
                s0 = s1;
                
                return s0;
            }
            
            function peg$parseCommentOrLB() {
                var s0, s1, s2;
                
                s0 = peg$parseComment();
                if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    s1 = [];
                    s2 = peg$parseLB();
                    if (s2 !== peg$FAILED) {
                        while (s2 !== peg$FAILED) {
                            s1.push(s2);
                            s2 = peg$parseLB();
                        }
                    } else {
                        s1 = peg$FAILED;
                    }
                    if (s1 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s1           = peg$c1();
                    }
                    s0 = s1;
                }
                
                return s0;
            }
            
            function peg$parseStatement() {
                var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16;
                
                s0 = peg$currPos;
                s1 = peg$parse_();
                if (s1 !== peg$FAILED) {
                    s2 = [];
                    s3 = peg$parseComment();
                    while (s3 !== peg$FAILED) {
                        s2.push(s3);
                        s3 = peg$parseComment();
                    }
                    if (s2 !== peg$FAILED) {
                        s3 = peg$parse_();
                        if (s3 !== peg$FAILED) {
                            s4 = peg$parseMarkerAnnotation();
                            if (s4 === peg$FAILED) {
                                s4 = null;
                            }
                            if (s4 !== peg$FAILED) {
                                s5 = peg$parse_();
                                if (s5 !== peg$FAILED) {
                                    s6 = peg$parseFieldModifiers();
                                    if (s6 !== peg$FAILED) {
                                        s7 = peg$parse__();
                                        if (s7 !== peg$FAILED) {
                                            s8 = peg$parseDataType();
                                            if (s8 !== peg$FAILED) {
                                                s9 = peg$parse__();
                                                if (s9 !== peg$FAILED) {
                                                    s10 = [];
                                                    s11 = peg$parseCharacter();
                                                    if (s11 !== peg$FAILED) {
                                                        while (s11 !== peg$FAILED) {
                                                            s10.push(s11);
                                                            s11 = peg$parseCharacter();
                                                        }
                                                    } else {
                                                        s10 = peg$FAILED;
                                                    }
                                                    if (s10 !== peg$FAILED) {
                                                        s11 = peg$parse_();
                                                        if (s11 !== peg$FAILED) {
                                                            s12 = peg$parseTraditionalArray();
                                                            if (s12 === peg$FAILED) {
                                                                s12 = null;
                                                            }
                                                            if (s12 !== peg$FAILED) {
                                                                s13 = peg$parseDefaultValueAssign();
                                                                if (s13 === peg$FAILED) {
                                                                    s13 = null;
                                                                }
                                                                if (s13 !== peg$FAILED) {
                                                                    if (input.charCodeAt(peg$currPos) === 59) {
                                                                        s14 = peg$c2;
                                                                        peg$currPos++;
                                                                    } else {
                                                                        s14 = peg$FAILED;
                                                                        if (peg$silentFails === 0) {
                                                                            peg$fail(peg$c3);
                                                                        }
                                                                    }
                                                                    if (s14 !== peg$FAILED) {
                                                                        s15 = peg$parse_();
                                                                        if (s15 !== peg$FAILED) {
                                                                            s16 = peg$parseCommentOrLB();
                                                                            if (s16 !== peg$FAILED) {
                                                                                peg$savedPos = s0;
                                                                                s1           = peg$c4(s2, s6, s8, s10, s12, s13, s16);
                                                                                s0           = s1;
                                                                            } else {
                                                                                peg$currPos = s0;
                                                                                s0          = peg$FAILED;
                                                                            }
                                                                        } else {
                                                                            peg$currPos = s0;
                                                                            s0          = peg$FAILED;
                                                                        }
                                                                    } else {
                                                                        peg$currPos = s0;
                                                                        s0          = peg$FAILED;
                                                                    }
                                                                } else {
                                                                    peg$currPos = s0;
                                                                    s0          = peg$FAILED;
                                                                }
                                                            } else {
                                                                peg$currPos = s0;
                                                                s0          = peg$FAILED;
                                                            }
                                                        } else {
                                                            peg$currPos = s0;
                                                            s0          = peg$FAILED;
                                                        }
                                                    } else {
                                                        peg$currPos = s0;
                                                        s0          = peg$FAILED;
                                                    }
                                                } else {
                                                    peg$currPos = s0;
                                                    s0          = peg$FAILED;
                                                }
                                            } else {
                                                peg$currPos = s0;
                                                s0          = peg$FAILED;
                                            }
                                        } else {
                                            peg$currPos = s0;
                                            s0          = peg$FAILED;
                                        }
                                    } else {
                                        peg$currPos = s0;
                                        s0          = peg$FAILED;
                                    }
                                } else {
                                    peg$currPos = s0;
                                    s0          = peg$FAILED;
                                }
                            } else {
                                peg$currPos = s0;
                                s0          = peg$FAILED;
                            }
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                } else {
                    peg$currPos = s0;
                    s0          = peg$FAILED;
                }
                if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    s1 = [];
                    s2 = peg$parseComment();
                    while (s2 !== peg$FAILED) {
                        s1.push(s2);
                        s2 = peg$parseComment();
                    }
                    if (s1 !== peg$FAILED) {
                        s2 = peg$parse_();
                        if (s2 !== peg$FAILED) {
                            s3 = peg$parseMarkerAnnotation();
                            if (s3 === peg$FAILED) {
                                s3 = null;
                            }
                            if (s3 !== peg$FAILED) {
                                s4 = peg$parse_();
                                if (s4 !== peg$FAILED) {
                                    if (input.substr(peg$currPos, 6) === peg$c5) {
                                        s5 = peg$c5;
                                        peg$currPos += 6;
                                    } else {
                                        s5 = peg$FAILED;
                                        if (peg$silentFails === 0) {
                                            peg$fail(peg$c6);
                                        }
                                    }
                                    if (s5 !== peg$FAILED) {
                                        s6 = peg$parse__();
                                        if (s6 !== peg$FAILED) {
                                            if (input.substr(peg$currPos, 5) === peg$c7) {
                                                s7 = peg$c7;
                                                peg$currPos += 5;
                                            } else {
                                                s7 = peg$FAILED;
                                                if (peg$silentFails === 0) {
                                                    peg$fail(peg$c8);
                                                }
                                            }
                                            if (s7 !== peg$FAILED) {
                                                s8 = peg$parse__();
                                                if (s8 !== peg$FAILED) {
                                                    s9 = peg$parseWord();
                                                    if (s9 !== peg$FAILED) {
                                                        s10 = peg$parseAnyWithoutTerminator();
                                                        if (s10 !== peg$FAILED) {
                                                            if (input.charCodeAt(peg$currPos) === 123) {
                                                                s11 = peg$c9;
                                                                peg$currPos++;
                                                            } else {
                                                                s11 = peg$FAILED;
                                                                if (peg$silentFails === 0) {
                                                                    peg$fail(peg$c10);
                                                                }
                                                            }
                                                            if (s11 !== peg$FAILED) {
                                                                s12 = [];
                                                                s13 = peg$parseLB();
                                                                while (s13 !== peg$FAILED) {
                                                                    s12.push(s13);
                                                                    s13 = peg$parseLB();
                                                                }
                                                                if (s12 !== peg$FAILED) {
                                                                    peg$savedPos = s0;
                                                                    s1           = peg$c11(s1, s9);
                                                                    s0           = s1;
                                                                } else {
                                                                    peg$currPos = s0;
                                                                    s0          = peg$FAILED;
                                                                }
                                                            } else {
                                                                peg$currPos = s0;
                                                                s0          = peg$FAILED;
                                                            }
                                                        } else {
                                                            peg$currPos = s0;
                                                            s0          = peg$FAILED;
                                                        }
                                                    } else {
                                                        peg$currPos = s0;
                                                        s0          = peg$FAILED;
                                                    }
                                                } else {
                                                    peg$currPos = s0;
                                                    s0          = peg$FAILED;
                                                }
                                            } else {
                                                peg$currPos = s0;
                                                s0          = peg$FAILED;
                                            }
                                        } else {
                                            peg$currPos = s0;
                                            s0          = peg$FAILED;
                                        }
                                    } else {
                                        peg$currPos = s0;
                                        s0          = peg$FAILED;
                                    }
                                } else {
                                    peg$currPos = s0;
                                    s0          = peg$FAILED;
                                }
                            } else {
                                peg$currPos = s0;
                                s0          = peg$FAILED;
                            }
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                    if (s0 === peg$FAILED) {
                        s0 = peg$currPos;
                        s1 = peg$parse_();
                        if (s1 !== peg$FAILED) {
                            if (input.charCodeAt(peg$currPos) === 125) {
                                s2 = peg$c12;
                                peg$currPos++;
                            } else {
                                s2 = peg$FAILED;
                                if (peg$silentFails === 0) {
                                    peg$fail(peg$c13);
                                }
                            }
                            if (s2 !== peg$FAILED) {
                                s3 = peg$parse_();
                                if (s3 !== peg$FAILED) {
                                    s4 = [];
                                    s5 = peg$parseLB();
                                    while (s5 !== peg$FAILED) {
                                        s4.push(s5);
                                        s5 = peg$parseLB();
                                    }
                                    if (s4 !== peg$FAILED) {
                                        peg$savedPos = s0;
                                        s1           = peg$c14();
                                        s0           = s1;
                                    } else {
                                        peg$currPos = s0;
                                        s0          = peg$FAILED;
                                    }
                                } else {
                                    peg$currPos = s0;
                                    s0          = peg$FAILED;
                                }
                            } else {
                                peg$currPos = s0;
                                s0          = peg$FAILED;
                            }
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                        if (s0 === peg$FAILED) {
                            s0 = peg$currPos;
                            s1 = peg$parseAnyWithoutLB();
                            if (s1 !== peg$FAILED) {
                                s2 = [];
                                s3 = peg$parseLB();
                                if (s3 !== peg$FAILED) {
                                    while (s3 !== peg$FAILED) {
                                        s2.push(s3);
                                        s3 = peg$parseLB();
                                    }
                                } else {
                                    s2 = peg$FAILED;
                                }
                                if (s2 !== peg$FAILED) {
                                    peg$savedPos = s0;
                                    s1           = peg$c15(s1);
                                    s0           = s1;
                                } else {
                                    peg$currPos = s0;
                                    s0          = peg$FAILED;
                                }
                            } else {
                                peg$currPos = s0;
                                s0          = peg$FAILED;
                            }
                        }
                    }
                }
                
                return s0;
            }
            
            function peg$parseTraditionalArray() {
                var s0, s1, s2, s3, s4, s5;
                
                s0 = peg$currPos;
                if (input.charCodeAt(peg$currPos) === 91) {
                    s1 = peg$c16;
                    peg$currPos++;
                } else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c17);
                    }
                }
                if (s1 !== peg$FAILED) {
                    s2 = peg$parse_();
                    if (s2 !== peg$FAILED) {
                        s3 = peg$parseInterger();
                        if (s3 === peg$FAILED) {
                            s3 = null;
                        }
                        if (s3 !== peg$FAILED) {
                            s4 = peg$parse_();
                            if (s4 !== peg$FAILED) {
                                if (input.charCodeAt(peg$currPos) === 93) {
                                    s5 = peg$c18;
                                    peg$currPos++;
                                } else {
                                    s5 = peg$FAILED;
                                    if (peg$silentFails === 0) {
                                        peg$fail(peg$c19);
                                    }
                                }
                                if (s5 !== peg$FAILED) {
                                    peg$savedPos = s0;
                                    s1           = peg$c20(s3);
                                    s0           = s1;
                                } else {
                                    peg$currPos = s0;
                                    s0          = peg$FAILED;
                                }
                            } else {
                                peg$currPos = s0;
                                s0          = peg$FAILED;
                            }
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                } else {
                    peg$currPos = s0;
                    s0          = peg$FAILED;
                }
                
                return s0;
            }
            
            function peg$parseDataType() {
                var s0, s1, s2, s3, s4, s5, s6;
                
                s0 = peg$currPos;
                if (input.substr(peg$currPos, 4) === peg$c21) {
                    s1 = peg$c21;
                    peg$currPos += 4;
                } else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c22);
                    }
                }
                if (s1 !== peg$FAILED) {
                    s2 = peg$parse_();
                    if (s2 !== peg$FAILED) {
                        if (input.charCodeAt(peg$currPos) === 60) {
                            s3 = peg$c23;
                            peg$currPos++;
                        } else {
                            s3 = peg$FAILED;
                            if (peg$silentFails === 0) {
                                peg$fail(peg$c24);
                            }
                        }
                        if (s3 !== peg$FAILED) {
                            s4 = peg$parseWord();
                            if (s4 !== peg$FAILED) {
                                s5 = peg$parse_();
                                if (s5 !== peg$FAILED) {
                                    if (input.charCodeAt(peg$currPos) === 62) {
                                        s6 = peg$c25;
                                        peg$currPos++;
                                    } else {
                                        s6 = peg$FAILED;
                                        if (peg$silentFails === 0) {
                                            peg$fail(peg$c26);
                                        }
                                    }
                                    if (s6 !== peg$FAILED) {
                                        peg$savedPos = s0;
                                        s1           = peg$c27(s4);
                                        s0           = s1;
                                    } else {
                                        peg$currPos = s0;
                                        s0          = peg$FAILED;
                                    }
                                } else {
                                    peg$currPos = s0;
                                    s0          = peg$FAILED;
                                }
                            } else {
                                peg$currPos = s0;
                                s0          = peg$FAILED;
                            }
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                } else {
                    peg$currPos = s0;
                    s0          = peg$FAILED;
                }
                if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    s1 = peg$parseWord();
                    if (s1 !== peg$FAILED) {
                        s2 = peg$parseTraditionalArray();
                        if (s2 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1           = peg$c28(s1, s2);
                            s0           = s1;
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                    if (s0 === peg$FAILED) {
                        s0 = peg$currPos;
                        s1 = peg$parseWord();
                        if (s1 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1           = peg$c29(s1);
                        }
                        s0 = s1;
                    }
                }
                
                return s0;
            }
            
            function peg$parseMarkerAnnotation() {
                var s0, s1, s2, s3, s4, s5, s6;
                
                s0 = peg$currPos;
                s1 = peg$parse_();
                if (s1 !== peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 64) {
                        s2 = peg$c30;
                        peg$currPos++;
                    } else {
                        s2 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c31);
                        }
                    }
                    if (s2 !== peg$FAILED) {
                        s3 = peg$parseWord();
                        if (s3 !== peg$FAILED) {
                            s4 = peg$parse_();
                            if (s4 !== peg$FAILED) {
                                s5 = [];
                                s6 = peg$parseLB();
                                while (s6 !== peg$FAILED) {
                                    s5.push(s6);
                                    s6 = peg$parseLB();
                                }
                                if (s5 !== peg$FAILED) {
                                    s1 = [s1, s2, s3, s4, s5];
                                    s0 = s1;
                                } else {
                                    peg$currPos = s0;
                                    s0          = peg$FAILED;
                                }
                            } else {
                                peg$currPos = s0;
                                s0          = peg$FAILED;
                            }
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                } else {
                    peg$currPos = s0;
                    s0          = peg$FAILED;
                }
                
                return s0;
            }
            
            function peg$parseDataTypeModifier() {
                var s0;
                
                if (input.substr(peg$currPos, 7) === peg$c32) {
                    s0 = peg$c32;
                    peg$currPos += 7;
                } else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c33);
                    }
                }
                if (s0 === peg$FAILED) {
                    if (input.substr(peg$currPos, 9) === peg$c34) {
                        s0 = peg$c34;
                        peg$currPos += 9;
                    } else {
                        s0 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c35);
                        }
                    }
                    if (s0 === peg$FAILED) {
                        if (input.substr(peg$currPos, 6) === peg$c5) {
                            s0 = peg$c5;
                            peg$currPos += 6;
                        } else {
                            s0 = peg$FAILED;
                            if (peg$silentFails === 0) {
                                peg$fail(peg$c6);
                            }
                        }
                    }
                }
                
                return s0;
            }
            
            function peg$parseStaticFields() {
                var s0;
                
                if (input.substr(peg$currPos, 6) === peg$c36) {
                    s0 = peg$c36;
                    peg$currPos += 6;
                } else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c37);
                    }
                }
                
                return s0;
            }
            
            function peg$parseFinalFields() {
                var s0;
                
                if (input.substr(peg$currPos, 5) === peg$c38) {
                    s0 = peg$c38;
                    peg$currPos += 5;
                } else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c39);
                    }
                }
                
                return s0;
            }
            
            function peg$parseTransientFields() {
                var s0;
                
                if (input.substr(peg$currPos, 9) === peg$c40) {
                    s0 = peg$c40;
                    peg$currPos += 9;
                } else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c41);
                    }
                }
                
                return s0;
            }
            
            function peg$parseVolatileFields() {
                var s0;
                
                if (input.substr(peg$currPos, 8) === peg$c42) {
                    s0 = peg$c42;
                    peg$currPos += 8;
                } else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c43);
                    }
                }
                
                return s0;
            }
            
            function peg$parseFieldModifiers() {
                var s0, s1, s2, s3, s4, s5;
                
                s0 = peg$currPos;
                s1 = peg$parseDataTypeModifier();
                if (s1 === peg$FAILED) {
                    s1 = null;
                }
                if (s1 !== peg$FAILED) {
                    s2 = peg$parseStaticFields();
                    if (s2 === peg$FAILED) {
                        s2 = null;
                    }
                    if (s2 !== peg$FAILED) {
                        s3 = peg$parseFinalFields();
                        if (s3 === peg$FAILED) {
                            s3 = null;
                        }
                        if (s3 !== peg$FAILED) {
                            s4 = peg$parseTransientFields();
                            if (s4 === peg$FAILED) {
                                s4 = null;
                            }
                            if (s4 !== peg$FAILED) {
                                s5 = peg$parseVolatileFields();
                                if (s5 === peg$FAILED) {
                                    s5 = null;
                                }
                                if (s5 !== peg$FAILED) {
                                    peg$savedPos = s0;
                                    s1           = peg$c44(s2, s3);
                                    s0           = s1;
                                } else {
                                    peg$currPos = s0;
                                    s0          = peg$FAILED;
                                }
                            } else {
                                peg$currPos = s0;
                                s0          = peg$FAILED;
                            }
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                } else {
                    peg$currPos = s0;
                    s0          = peg$FAILED;
                }
                
                return s0;
            }
            
            function peg$parseDefaultValueAssign() {
                var s0, s1, s2, s3, s4, s5;
                
                s0 = peg$currPos;
                s1 = peg$parse_();
                if (s1 !== peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 61) {
                        s2 = peg$c45;
                        peg$currPos++;
                    } else {
                        s2 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c46);
                        }
                    }
                    if (s2 !== peg$FAILED) {
                        s3 = peg$parse_();
                        if (s3 !== peg$FAILED) {
                            s4 = peg$parseDefaultValue();
                            if (s4 !== peg$FAILED) {
                                s5 = peg$parse_();
                                if (s5 !== peg$FAILED) {
                                    peg$savedPos = s0;
                                    s1           = peg$c47(s4);
                                    s0           = s1;
                                } else {
                                    peg$currPos = s0;
                                    s0          = peg$FAILED;
                                }
                            } else {
                                peg$currPos = s0;
                                s0          = peg$FAILED;
                            }
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                } else {
                    peg$currPos = s0;
                    s0          = peg$FAILED;
                }
                
                return s0;
            }
            
            function peg$parseArrayEle() {
                var s0;
                
                s0 = peg$parseString();
                if (s0 === peg$FAILED) {
                    s0 = peg$parseNumber();
                }
                
                return s0;
            }
            
            function peg$parseArrays() {
                var s0, s1, s2, s3, s4, s5, s6, s7;
                
                s0 = peg$currPos;
                s1 = peg$parseArrayEle();
                if (s1 !== peg$FAILED) {
                    s2 = peg$parse_();
                    if (s2 !== peg$FAILED) {
                        s3 = [];
                        s4 = peg$currPos;
                        if (input.charCodeAt(peg$currPos) === 44) {
                            s5 = peg$c48;
                            peg$currPos++;
                        } else {
                            s5 = peg$FAILED;
                            if (peg$silentFails === 0) {
                                peg$fail(peg$c49);
                            }
                        }
                        if (s5 !== peg$FAILED) {
                            s6 = peg$parse_();
                            if (s6 !== peg$FAILED) {
                                s7 = peg$parseArrayEle();
                                if (s7 !== peg$FAILED) {
                                    s5 = [s5, s6, s7];
                                    s4 = s5;
                                } else {
                                    peg$currPos = s4;
                                    s4          = peg$FAILED;
                                }
                            } else {
                                peg$currPos = s4;
                                s4          = peg$FAILED;
                            }
                        } else {
                            peg$currPos = s4;
                            s4          = peg$FAILED;
                        }
                        if (s4 !== peg$FAILED) {
                            while (s4 !== peg$FAILED) {
                                s3.push(s4);
                                s4 = peg$currPos;
                                if (input.charCodeAt(peg$currPos) === 44) {
                                    s5 = peg$c48;
                                    peg$currPos++;
                                } else {
                                    s5 = peg$FAILED;
                                    if (peg$silentFails === 0) {
                                        peg$fail(peg$c49);
                                    }
                                }
                                if (s5 !== peg$FAILED) {
                                    s6 = peg$parse_();
                                    if (s6 !== peg$FAILED) {
                                        s7 = peg$parseArrayEle();
                                        if (s7 !== peg$FAILED) {
                                            s5 = [s5, s6, s7];
                                            s4 = s5;
                                        } else {
                                            peg$currPos = s4;
                                            s4          = peg$FAILED;
                                        }
                                    } else {
                                        peg$currPos = s4;
                                        s4          = peg$FAILED;
                                    }
                                } else {
                                    peg$currPos = s4;
                                    s4          = peg$FAILED;
                                }
                            }
                        } else {
                            s3 = peg$FAILED;
                        }
                        if (s3 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1           = peg$c50(s1, s3);
                            s0           = s1;
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                } else {
                    peg$currPos = s0;
                    s0          = peg$FAILED;
                }
                
                return s0;
            }
            
            function peg$parseDefaultValue() {
                var s0, s1, s2, s3, s4, s5, s6, s7, s8;
                
                s0 = peg$parseArrays();
                if (s0 === peg$FAILED) {
                    s0 = peg$parseArrayEle();
                    if (s0 === peg$FAILED) {
                        s0 = peg$currPos;
                        if (input.charCodeAt(peg$currPos) === 91) {
                            s1 = peg$c16;
                            peg$currPos++;
                        } else {
                            s1 = peg$FAILED;
                            if (peg$silentFails === 0) {
                                peg$fail(peg$c17);
                            }
                        }
                        if (s1 !== peg$FAILED) {
                            s2 = peg$parse_();
                            if (s2 !== peg$FAILED) {
                                s3 = peg$parseDefaultValue();
                                if (s3 !== peg$FAILED) {
                                    s4 = [];
                                    s5 = peg$currPos;
                                    if (input.charCodeAt(peg$currPos) === 44) {
                                        s6 = peg$c48;
                                        peg$currPos++;
                                    } else {
                                        s6 = peg$FAILED;
                                        if (peg$silentFails === 0) {
                                            peg$fail(peg$c49);
                                        }
                                    }
                                    if (s6 !== peg$FAILED) {
                                        s7 = peg$parse_();
                                        if (s7 !== peg$FAILED) {
                                            s8 = peg$parseDefaultValue();
                                            if (s8 !== peg$FAILED) {
                                                s6 = [s6, s7, s8];
                                                s5 = s6;
                                            } else {
                                                peg$currPos = s5;
                                                s5          = peg$FAILED;
                                            }
                                        } else {
                                            peg$currPos = s5;
                                            s5          = peg$FAILED;
                                        }
                                    } else {
                                        peg$currPos = s5;
                                        s5          = peg$FAILED;
                                    }
                                    while (s5 !== peg$FAILED) {
                                        s4.push(s5);
                                        s5 = peg$currPos;
                                        if (input.charCodeAt(peg$currPos) === 44) {
                                            s6 = peg$c48;
                                            peg$currPos++;
                                        } else {
                                            s6 = peg$FAILED;
                                            if (peg$silentFails === 0) {
                                                peg$fail(peg$c49);
                                            }
                                        }
                                        if (s6 !== peg$FAILED) {
                                            s7 = peg$parse_();
                                            if (s7 !== peg$FAILED) {
                                                s8 = peg$parseDefaultValue();
                                                if (s8 !== peg$FAILED) {
                                                    s6 = [s6, s7, s8];
                                                    s5 = s6;
                                                } else {
                                                    peg$currPos = s5;
                                                    s5          = peg$FAILED;
                                                }
                                            } else {
                                                peg$currPos = s5;
                                                s5          = peg$FAILED;
                                            }
                                        } else {
                                            peg$currPos = s5;
                                            s5          = peg$FAILED;
                                        }
                                    }
                                    if (s4 !== peg$FAILED) {
                                        s5 = peg$parse_();
                                        if (s5 !== peg$FAILED) {
                                            if (input.charCodeAt(peg$currPos) === 93) {
                                                s6 = peg$c18;
                                                peg$currPos++;
                                            } else {
                                                s6 = peg$FAILED;
                                                if (peg$silentFails === 0) {
                                                    peg$fail(peg$c19);
                                                }
                                            }
                                            if (s6 !== peg$FAILED) {
                                                peg$savedPos = s0;
                                                s1           = peg$c51(s3, s4);
                                                s0           = s1;
                                            } else {
                                                peg$currPos = s0;
                                                s0          = peg$FAILED;
                                            }
                                        } else {
                                            peg$currPos = s0;
                                            s0          = peg$FAILED;
                                        }
                                    } else {
                                        peg$currPos = s0;
                                        s0          = peg$FAILED;
                                    }
                                } else {
                                    peg$currPos = s0;
                                    s0          = peg$FAILED;
                                }
                            } else {
                                peg$currPos = s0;
                                s0          = peg$FAILED;
                            }
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                    }
                }
                
                return s0;
            }
            
            function peg$parseComment() {
                var s0, s1, s2, s3, s4, s5, s6;
                
                s0 = peg$currPos;
                s1 = peg$parse_();
                if (s1 !== peg$FAILED) {
                    if (input.substr(peg$currPos, 2) === peg$c52) {
                        s2 = peg$c52;
                        peg$currPos += 2;
                    } else {
                        s2 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c53);
                        }
                    }
                    if (s2 !== peg$FAILED) {
                        s3 = peg$parse_();
                        if (s3 !== peg$FAILED) {
                            s4 = peg$parseAnyWithoutLB();
                            if (s4 !== peg$FAILED) {
                                s5 = [];
                                s6 = peg$parseLB();
                                if (s6 !== peg$FAILED) {
                                    while (s6 !== peg$FAILED) {
                                        s5.push(s6);
                                        s6 = peg$parseLB();
                                    }
                                } else {
                                    s5 = peg$FAILED;
                                }
                                if (s5 !== peg$FAILED) {
                                    peg$savedPos = s0;
                                    s1           = peg$c54(s4);
                                    s0           = s1;
                                } else {
                                    peg$currPos = s0;
                                    s0          = peg$FAILED;
                                }
                            } else {
                                peg$currPos = s0;
                                s0          = peg$FAILED;
                            }
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                } else {
                    peg$currPos = s0;
                    s0          = peg$FAILED;
                }
                if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    s1 = peg$parse_();
                    if (s1 !== peg$FAILED) {
                        s2 = peg$parseCommentStart();
                        if (s2 !== peg$FAILED) {
                            s3 = peg$parseAnyWithoutCommentEnd();
                            if (s3 !== peg$FAILED) {
                                s4 = peg$parseCommentEnd();
                                if (s4 !== peg$FAILED) {
                                    s5 = [];
                                    s6 = peg$parseLB();
                                    while (s6 !== peg$FAILED) {
                                        s5.push(s6);
                                        s6 = peg$parseLB();
                                    }
                                    if (s5 !== peg$FAILED) {
                                        peg$savedPos = s0;
                                        s1           = peg$c55(s3);
                                        s0           = s1;
                                    } else {
                                        peg$currPos = s0;
                                        s0          = peg$FAILED;
                                    }
                                } else {
                                    peg$currPos = s0;
                                    s0          = peg$FAILED;
                                }
                            } else {
                                peg$currPos = s0;
                                s0          = peg$FAILED;
                            }
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                }
                
                return s0;
            }
            
            function peg$parseCommentStart() {
                var s0, s1, s2, s3;
                
                s0 = peg$currPos;
                if (peg$c56.test(input.charAt(peg$currPos))) {
                    s1 = input.charAt(peg$currPos);
                    peg$currPos++;
                } else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c57);
                    }
                }
                if (s1 !== peg$FAILED) {
                    s2 = [];
                    if (peg$c58.test(input.charAt(peg$currPos))) {
                        s3 = input.charAt(peg$currPos);
                        peg$currPos++;
                    } else {
                        s3 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c59);
                        }
                    }
                    if (s3 !== peg$FAILED) {
                        while (s3 !== peg$FAILED) {
                            s2.push(s3);
                            if (peg$c58.test(input.charAt(peg$currPos))) {
                                s3 = input.charAt(peg$currPos);
                                peg$currPos++;
                            } else {
                                s3 = peg$FAILED;
                                if (peg$silentFails === 0) {
                                    peg$fail(peg$c59);
                                }
                            }
                        }
                    } else {
                        s2 = peg$FAILED;
                    }
                    if (s2 !== peg$FAILED) {
                        s1 = [s1, s2];
                        s0 = s1;
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                } else {
                    peg$currPos = s0;
                    s0          = peg$FAILED;
                }
                
                return s0;
            }
            
            function peg$parseCommentEnd() {
                var s0, s1, s2;
                
                s0 = peg$currPos;
                s1 = [];
                if (peg$c58.test(input.charAt(peg$currPos))) {
                    s2 = input.charAt(peg$currPos);
                    peg$currPos++;
                } else {
                    s2 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c59);
                    }
                }
                if (s2 !== peg$FAILED) {
                    while (s2 !== peg$FAILED) {
                        s1.push(s2);
                        if (peg$c58.test(input.charAt(peg$currPos))) {
                            s2 = input.charAt(peg$currPos);
                            peg$currPos++;
                        } else {
                            s2 = peg$FAILED;
                            if (peg$silentFails === 0) {
                                peg$fail(peg$c59);
                            }
                        }
                    }
                } else {
                    s1 = peg$FAILED;
                }
                if (s1 !== peg$FAILED) {
                    if (peg$c56.test(input.charAt(peg$currPos))) {
                        s2 = input.charAt(peg$currPos);
                        peg$currPos++;
                    } else {
                        s2 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c57);
                        }
                    }
                    if (s2 !== peg$FAILED) {
                        s1 = [s1, s2];
                        s0 = s1;
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                } else {
                    peg$currPos = s0;
                    s0          = peg$FAILED;
                }
                
                return s0;
            }
            
            function peg$parseAnyWithoutCommentEnd() {
                var s0, s1, s2, s3, s4;
                
                s0 = peg$currPos;
                s1 = [];
                s2 = peg$currPos;
                s3 = peg$currPos;
                peg$silentFails++;
                if (input.substr(peg$currPos, 2) === peg$c60) {
                    s4 = peg$c60;
                    peg$currPos += 2;
                } else {
                    s4 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c61);
                    }
                }
                peg$silentFails--;
                if (s4 === peg$FAILED) {
                    s3 = void 0;
                } else {
                    peg$currPos = s3;
                    s3          = peg$FAILED;
                }
                if (s3 !== peg$FAILED) {
                    if (input.length > peg$currPos) {
                        s4 = input.charAt(peg$currPos);
                        peg$currPos++;
                    } else {
                        s4 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c62);
                        }
                    }
                    if (s4 !== peg$FAILED) {
                        s3 = [s3, s4];
                        s2 = s3;
                    } else {
                        peg$currPos = s2;
                        s2          = peg$FAILED;
                    }
                } else {
                    peg$currPos = s2;
                    s2          = peg$FAILED;
                }
                while (s2 !== peg$FAILED) {
                    s1.push(s2);
                    s2 = peg$currPos;
                    s3 = peg$currPos;
                    peg$silentFails++;
                    if (input.substr(peg$currPos, 2) === peg$c60) {
                        s4 = peg$c60;
                        peg$currPos += 2;
                    } else {
                        s4 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c61);
                        }
                    }
                    peg$silentFails--;
                    if (s4 === peg$FAILED) {
                        s3 = void 0;
                    } else {
                        peg$currPos = s3;
                        s3          = peg$FAILED;
                    }
                    if (s3 !== peg$FAILED) {
                        if (input.length > peg$currPos) {
                            s4 = input.charAt(peg$currPos);
                            peg$currPos++;
                        } else {
                            s4 = peg$FAILED;
                            if (peg$silentFails === 0) {
                                peg$fail(peg$c62);
                            }
                        }
                        if (s4 !== peg$FAILED) {
                            s3 = [s3, s4];
                            s2 = s3;
                        } else {
                            peg$currPos = s2;
                            s2          = peg$FAILED;
                        }
                    } else {
                        peg$currPos = s2;
                        s2          = peg$FAILED;
                    }
                }
                if (s1 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1           = peg$c63(s1);
                }
                s0 = s1;
                
                return s0;
            }
            
            function peg$parseString() {
                var s0, s1, s2, s3;
                
                s0 = peg$currPos;
                if (input.charCodeAt(peg$currPos) === 34) {
                    s1 = peg$c64;
                    peg$currPos++;
                } else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c65);
                    }
                }
                if (s1 !== peg$FAILED) {
                    s2 = [];
                    if (peg$c66.test(input.charAt(peg$currPos))) {
                        s3 = input.charAt(peg$currPos);
                        peg$currPos++;
                    } else {
                        s3 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c67);
                        }
                    }
                    if (s3 !== peg$FAILED) {
                        while (s3 !== peg$FAILED) {
                            s2.push(s3);
                            if (peg$c66.test(input.charAt(peg$currPos))) {
                                s3 = input.charAt(peg$currPos);
                                peg$currPos++;
                            } else {
                                s3 = peg$FAILED;
                                if (peg$silentFails === 0) {
                                    peg$fail(peg$c67);
                                }
                            }
                        }
                    } else {
                        s2 = peg$FAILED;
                    }
                    if (s2 !== peg$FAILED) {
                        if (input.charCodeAt(peg$currPos) === 34) {
                            s3 = peg$c64;
                            peg$currPos++;
                        } else {
                            s3 = peg$FAILED;
                            if (peg$silentFails === 0) {
                                peg$fail(peg$c65);
                            }
                        }
                        if (s3 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1           = peg$c68(s2);
                            s0           = s1;
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                } else {
                    peg$currPos = s0;
                    s0          = peg$FAILED;
                }
                
                return s0;
            }
            
            function peg$parseNumber() {
                var s0, s1;
                
                s0 = peg$currPos;
                s1 = peg$parseFloat();
                if (s1 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1           = peg$c69(s1);
                }
                s0 = s1;
                if (s0 === peg$FAILED) {
                    s0 = peg$parseInterger();
                }
                
                return s0;
            }
            
            function peg$parseDIGIT() {
                var s0;
                
                if (peg$c70.test(input.charAt(peg$currPos))) {
                    s0 = input.charAt(peg$currPos);
                    peg$currPos++;
                } else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c71);
                    }
                }
                
                return s0;
            }
            
            function peg$parseFloat_Exponent() {
                var s0, s1, s2, s3, s4;
                
                s0 = peg$currPos;
                if (peg$c72.test(input.charAt(peg$currPos))) {
                    s1 = input.charAt(peg$currPos);
                    peg$currPos++;
                } else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c73);
                    }
                }
                if (s1 !== peg$FAILED) {
                    if (peg$c74.test(input.charAt(peg$currPos))) {
                        s2 = input.charAt(peg$currPos);
                        peg$currPos++;
                    } else {
                        s2 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c75);
                        }
                    }
                    if (s2 === peg$FAILED) {
                        s2 = null;
                    }
                    if (s2 !== peg$FAILED) {
                        s3 = [];
                        s4 = peg$parseDIGIT();
                        if (s4 !== peg$FAILED) {
                            while (s4 !== peg$FAILED) {
                                s3.push(s4);
                                s4 = peg$parseDIGIT();
                            }
                        } else {
                            s3 = peg$FAILED;
                        }
                        if (s3 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1           = peg$c76(s1, s2, s3);
                            s0           = s1;
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                } else {
                    peg$currPos = s0;
                    s0          = peg$FAILED;
                }
                
                return s0;
            }
            
            function peg$parseFloat() {
                var s0, s1, s2, s3, s4, s5;
                
                s0 = peg$currPos;
                if (peg$c74.test(input.charAt(peg$currPos))) {
                    s1 = input.charAt(peg$currPos);
                    peg$currPos++;
                } else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c75);
                    }
                }
                if (s1 === peg$FAILED) {
                    s1 = null;
                }
                if (s1 !== peg$FAILED) {
                    s2 = [];
                    s3 = peg$parseDIGIT();
                    while (s3 !== peg$FAILED) {
                        s2.push(s3);
                        s3 = peg$parseDIGIT();
                    }
                    if (s2 !== peg$FAILED) {
                        if (input.charCodeAt(peg$currPos) === 46) {
                            s3 = peg$c77;
                            peg$currPos++;
                        } else {
                            s3 = peg$FAILED;
                            if (peg$silentFails === 0) {
                                peg$fail(peg$c78);
                            }
                        }
                        if (s3 !== peg$FAILED) {
                            s4 = [];
                            s5 = peg$parseDIGIT();
                            if (s5 !== peg$FAILED) {
                                while (s5 !== peg$FAILED) {
                                    s4.push(s5);
                                    s5 = peg$parseDIGIT();
                                }
                            } else {
                                s4 = peg$FAILED;
                            }
                            if (s4 !== peg$FAILED) {
                                s5 = peg$parseFloat_Exponent();
                                if (s5 === peg$FAILED) {
                                    s5 = null;
                                }
                                if (s5 !== peg$FAILED) {
                                    s1 = [s1, s2, s3, s4, s5];
                                    s0 = s1;
                                } else {
                                    peg$currPos = s0;
                                    s0          = peg$FAILED;
                                }
                            } else {
                                peg$currPos = s0;
                                s0          = peg$FAILED;
                            }
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                } else {
                    peg$currPos = s0;
                    s0          = peg$FAILED;
                }
                if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    if (peg$c74.test(input.charAt(peg$currPos))) {
                        s1 = input.charAt(peg$currPos);
                        peg$currPos++;
                    } else {
                        s1 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c75);
                        }
                    }
                    if (s1 === peg$FAILED) {
                        s1 = null;
                    }
                    if (s1 !== peg$FAILED) {
                        s2 = [];
                        s3 = peg$parseDIGIT();
                        if (s3 !== peg$FAILED) {
                            while (s3 !== peg$FAILED) {
                                s2.push(s3);
                                s3 = peg$parseDIGIT();
                            }
                        } else {
                            s2 = peg$FAILED;
                        }
                        if (s2 !== peg$FAILED) {
                            s3 = peg$parseFloat_Exponent();
                            if (s3 !== peg$FAILED) {
                                s1 = [s1, s2, s3];
                                s0 = s1;
                            } else {
                                peg$currPos = s0;
                                s0          = peg$FAILED;
                            }
                        } else {
                            peg$currPos = s0;
                            s0          = peg$FAILED;
                        }
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                }
                
                return s0;
            }
            
            function peg$parseInterger() {
                var s0, s1, s2, s3;
                
                s0 = peg$currPos;
                if (peg$c74.test(input.charAt(peg$currPos))) {
                    s1 = input.charAt(peg$currPos);
                    peg$currPos++;
                } else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c75);
                    }
                }
                if (s1 === peg$FAILED) {
                    s1 = null;
                }
                if (s1 !== peg$FAILED) {
                    s2 = [];
                    s3 = peg$parseDIGIT();
                    if (s3 !== peg$FAILED) {
                        while (s3 !== peg$FAILED) {
                            s2.push(s3);
                            s3 = peg$parseDIGIT();
                        }
                    } else {
                        s2 = peg$FAILED;
                    }
                    if (s2 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s1           = peg$c79(s1, s2);
                        s0           = s1;
                    } else {
                        peg$currPos = s0;
                        s0          = peg$FAILED;
                    }
                } else {
                    peg$currPos = s0;
                    s0          = peg$FAILED;
                }
                
                return s0;
            }
            
            function peg$parseWord() {
                var s0, s1, s2;
                
                s0 = peg$currPos;
                s1 = [];
                s2 = peg$parseCharacter();
                if (s2 !== peg$FAILED) {
                    while (s2 !== peg$FAILED) {
                        s1.push(s2);
                        s2 = peg$parseCharacter();
                    }
                } else {
                    s1 = peg$FAILED;
                }
                if (s1 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1           = peg$c80(s1);
                }
                s0 = s1;
                
                return s0;
            }
            
            function peg$parseCharacter() {
                var s0;
                
                if (peg$c81.test(input.charAt(peg$currPos))) {
                    s0 = input.charAt(peg$currPos);
                    peg$currPos++;
                } else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c82);
                    }
                }
                
                return s0;
            }
            
            function peg$parseWS() {
                var s0, s1;
                
                peg$silentFails++;
                if (peg$c84.test(input.charAt(peg$currPos))) {
                    s0 = input.charAt(peg$currPos);
                    peg$currPos++;
                } else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c85);
                    }
                }
                peg$silentFails--;
                if (s0 === peg$FAILED) {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c83);
                    }
                }
                
                return s0;
            }
            
            function peg$parse_() {
                var s0, s1;
                
                peg$silentFails++;
                s0 = [];
                s1 = peg$parseWS();
                while (s1 !== peg$FAILED) {
                    s0.push(s1);
                    s1 = peg$parseWS();
                }
                peg$silentFails--;
                if (s0 === peg$FAILED) {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c86);
                    }
                }
                
                return s0;
            }
            
            function peg$parse__() {
                var s0, s1;
                
                peg$silentFails++;
                s0 = [];
                s1 = peg$parseWS();
                if (s1 !== peg$FAILED) {
                    while (s1 !== peg$FAILED) {
                        s0.push(s1);
                        s1 = peg$parseWS();
                    }
                } else {
                    s0 = peg$FAILED;
                }
                peg$silentFails--;
                if (s0 === peg$FAILED) {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c87);
                    }
                }
                
                return s0;
            }
            
            function peg$parseLB() {
                var s0;
                
                if (peg$c88.test(input.charAt(peg$currPos))) {
                    s0 = input.charAt(peg$currPos);
                    peg$currPos++;
                } else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c89);
                    }
                }
                
                return s0;
            }
            
            function peg$parseAnyWithoutTerminator() {
                var s0, s1;
                
                s0 = [];
                if (peg$c90.test(input.charAt(peg$currPos))) {
                    s1 = input.charAt(peg$currPos);
                    peg$currPos++;
                } else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c91);
                    }
                }
                while (s1 !== peg$FAILED) {
                    s0.push(s1);
                    if (peg$c90.test(input.charAt(peg$currPos))) {
                        s1 = input.charAt(peg$currPos);
                        peg$currPos++;
                    } else {
                        s1 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c91);
                        }
                    }
                }
                
                return s0;
            }
            
            function peg$parseAnyWithoutLB() {
                var s0, s1;
                
                s0 = [];
                if (peg$c92.test(input.charAt(peg$currPos))) {
                    s1 = input.charAt(peg$currPos);
                    peg$currPos++;
                } else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c93);
                    }
                }
                while (s1 !== peg$FAILED) {
                    s0.push(s1);
                    if (peg$c92.test(input.charAt(peg$currPos))) {
                        s1 = input.charAt(peg$currPos);
                        peg$currPos++;
                    } else {
                        s1 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c93);
                        }
                    }
                }
                
                return s0;
            }
            
            function peg$parseAny() {
                var s0, s1;
                
                s0 = [];
                if (input.length > peg$currPos) {
                    s1 = input.charAt(peg$currPos);
                    peg$currPos++;
                } else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c62);
                    }
                }
                while (s1 !== peg$FAILED) {
                    s0.push(s1);
                    if (input.length > peg$currPos) {
                        s1 = input.charAt(peg$currPos);
                        peg$currPos++;
                    } else {
                        s1 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c62);
                        }
                    }
                }
                
                return s0;
            }
            
            peg$result = peg$startRuleFunction();
            
            if (peg$result !== peg$FAILED && peg$currPos === input.length) {
                return peg$result;
            } else {
                if (peg$result !== peg$FAILED && peg$currPos < input.length) {
                    peg$fail(peg$endExpectation());
                }
                
                throw peg$buildStructuredError(
                    peg$maxFailExpected,
                    peg$maxFailPos < input.length ? input.charAt(peg$maxFailPos) : null,
                    peg$maxFailPos < input.length
                        ? peg$computeLocation(peg$maxFailPos, peg$maxFailPos + 1)
                        : peg$computeLocation(peg$maxFailPos, peg$maxFailPos)
                );
            }
        }
        
        return {
            SyntaxError: peg$SyntaxError,
            parse      : peg$parse
        };
    };
    if (typeof NEJ !== 'undefined') {
        NEJ.define(jsonBean);
    } else if (typeof(module) !== 'undefined') {
        module.exports = jsonBean();
    } else {
        return jsonBean();
    }
    
})();
